#ifndef APPLICATION_GPS_H_
#define APPLICATION_GPS_H_

#include <zephyr/types.h>

struct gps_sat_data_t {
  void *fifo_reserved;
  uint8_t gps;
  uint8_t glonass;
  uint8_t galileo;
};

struct gps_data_t {
  void *fifo_reserved;
  int32_t latitude;  /*!< Latitude in units of degrees */
  int32_t longitude; /*!< Longitude in units of degrees */
  int32_t altitude; /*!< Longitude in units of degrees */
  uint16_t dop_h;        /*!< Horizontal dilution of precision */
  uint16_t dop_v;        /*!< Vertical dilution of precision */
  uint32_t acc_h;
  uint32_t acc_v;
  uint16_t speed;     /*!< Ground speed in knots */
  uint16_t course;    /*!< Ground coarse */
};

//extern K_FIFO_DEFINE(fifo_gps_sat_data);
extern struct k_fifo fifo_gps_sat_data;
extern struct k_fifo fifo_gps_data;
extern struct k_sem gps_data_tosend;
extern struct k_sem gps_init_ok;

void gpsPower(bool state);
void gpsBoost(bool state);

#endif /* APPLICATION_GPS_H_ */
