#include "ruuvi.h"
#include "calendar.h"

#include <zephyr/logging/log.h>
LOG_MODULE_REGISTER(ruuvi);

struct s_database database;

uint8_t mfg_ruuvi_data[] = { 0x99, 0x04, 0x03, 0x64, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x0b, 0xb8 };

uint8_t* ruuvi_getPayload()
{
  return mfg_ruuvi_data;
}

void ruuvi_updateTemperature(struct sensor_value *temperature)
{
  int8_t truuvi1;
  uint8_t truuvi2;

  truuvi1 = temperature->val1;
  truuvi2 = (uint8_t) (temperature->val2/10000);

  mfg_ruuvi_data[4] = truuvi1;
  mfg_ruuvi_data[5] = truuvi2;
}

void ruuvi_updatePressure(struct sensor_value *pressure)
{
  
  uint32_t pruuvi;

  pruuvi = (uint32_t)((pressure->val1*1000)+(pressure->val2/1000)-50000);

  mfg_ruuvi_data[7] = pruuvi;
  mfg_ruuvi_data[6] = pruuvi >> 8;
}

void ruuvi_updateBattery(uint16_t batt_mV)
{
  mfg_ruuvi_data[15] = batt_mV;
  mfg_ruuvi_data[14] = batt_mV >> 8;
}

void addRecord(uint8_t type, int16_t value)
{
    if(TsOK() == true)
    {
    if(database.index == SIZE_DB) {
        database.index = 0;
    }
    database.db[database.index].type = type;
    database.db[database.index].value = value;
    uint32_t ts = getTs();
    database.db[database.index].timestamp = ts;
    LOG_INF("Record index %d ts %u type %d value %d", database.index, ts, type, value);
    database.index = database.index + 1;
    }
}

