#include <zephyr/types.h>
#include <zephyr/drivers/sensor.h>

#ifndef __RUUVI_H__
#define __RUUVI_H__

void addRecord(uint8_t type, int16_t value);
void ruuvi_updateTemperature(struct sensor_value *temperature);
void ruuvi_updatePressure(struct sensor_value *pressure);
void ruuvi_updateBattery(uint16_t batt_mV);
uint8_t* ruuvi_getPayload();

#define SIZE_DB 2160

struct s_record {
    uint32_t timestamp;
    uint8_t type;
    int16_t value;
};

struct s_database {
    uint16_t index;
    struct s_record db[SIZE_DB];
};

extern struct s_database database;

#endif
